#Spawn
execute at @e[type=spider,name="Mega Cube Spawn Egg"] run summon magma_cube ~ ~3 ~ {Invulnerable:1,Glowing:1b,Size:5,Tags:["MegaCube"],ArmorItems:[{id:"leather_chestplate",Count:1b,tag:{Unbreakable:1,BossLoot:1b,Item:"MagmaArm",HideFlags:17,display:{color:11546150,Name:"{\"text\":\"Magma Chestplate\",\"color\":\"light_purple\"}"}}},{id:"player_head",Count:1b,tag:{BossLoot:1b,Item:"MegaCubeHead",SkullOwner:"magmacube"}},{},{}],ArmorDropChances:[1.0f,1.0f,0.0f,0.0f],Health:3,Attributes:[{Name:"generic.maxHealth",Base:3}],AbsorptionAmount:130.0f,DeathLootTable:"minecraft:entities/vex",Sience:1,persistenceRequired:1,NoAI:1,CustomName:"{\"text\":\"   \"}"}
execute as @e[type=spider,name="Mega Cube Spawn Egg"] run data merge entity @s {DeathLootTable:"minecraft:entities/vex"}
kill @e[type=spider,name="Mega Cube Spawn Egg"]

scoreboard players add @e[type=magma_cube,tag=MegaCube] LifeTime 1
execute at @e[type=magma_cube,tag=MegaCube,scores={LifeTime=1}] unless blocks ~-2 ~-2 ~-2 ~2 ~2 ~2 0 0 0 all run give @p spider_spawn_egg{Enchantments:[{id:"smite",lvl:0}],HideFlags:17,display:{Name:"{\"text\":\"Mega Cube Spawn Egg\"}",Lore:["\"This is the final boss\""]}}
execute at @e[type=magma_cube,tag=MegaCube,scores={LifeTime=1}] unless blocks ~-2 ~-2 ~-2 ~2 ~2 ~2 0 0 0 all run tellraw @a [{"color":"red","text":"You could spawn the mega cube in an empty area"}]
execute as @e[type=magma_cube,tag=MegaCube,scores={LifeTime=1}] at @s unless blocks ~-2 ~-2 ~-2 ~2 ~2 ~2 0 0 0 all run data merge entity @s {ArmorDropChances:[0.0f,0.0f,0.0f,0.0f]}
execute as @e[type=magma_cube,tag=MegaCube,scores={LifeTime=1}] at @s unless blocks ~-2 ~-2 ~-2 ~2 ~2 ~2 0 0 0 all run kill @s

#Bossbar
execute store result bossbar skyextra:mega_cube value run data get entity @e[type=minecraft:magma_cube,tag=MegaCube,limit=1] AbsorptionAmount
execute at @e[type=minecraft:magma_cube,tag=MegaCube,limit=1] run bossbar set skyextra:mega_cube players @a[distance=..40]
execute unless entity @e[type=magma_cube,tag=MegaCube,limit=1] run bossbar set skyextra:mega_cube players @a[tag=None]

#SpecialAttack_1
scoreboard players add @e[type=magma_cube,tag=MegaCube] special_atk_1 1
execute at @e[type=magma_cube,tag=MegaCube,scores={special_atk_1=240}] run particle crit ~ ~ ~ 0.1 0.1 0.1 40 270
execute at @e[type=magma_cube,tag=MegaCube,scores={special_atk_1=240}] run playsound item.shield.break master @a ~ ~ ~ 10 2
execute as @e[type=magma_cube,tag=MegaCube,limit=1] if score @s special_atk_1 matches 240 run data merge entity @s {Invulnerable:0,Glowing:0b}
execute as @e[type=magma_cube,tag=MegaCube,limit=1] if score @s special_atk_1 matches 300 run data merge entity @s {Invulnerable:1,Glowing:1b}
scoreboard players reset @e[type=magma_cube,tag=MegaCube,scores={special_atk_1=750}] special_atk_1

#SpecialAttack_2
execute as @e[type=magma_cube,tag=MegaCube] at @s if entity @a[distance=..30] run scoreboard players add @s special_atk_2 1
execute at @e[type=magma_cube,tag=MegaCube,scores={special_atk_2=80}] run summon blaze ~-2 ~1 ~-1 {Tags:["CanHealBoss"]}
execute at @e[type=magma_cube,tag=MegaCube,scores={special_atk_2=80}] run summon blaze ~1 ~-3 ~2 {Tags:["CanHealBoss"]}
scoreboard players reset @e[type=magma_cube,tag=MegaCube,scores={special_atk_2=200}] special_atk_2

scoreboard players add @e[type=blaze,tag=CanHealBoss] LifeTime 1
execute at @e[type=blaze,scores={LifeTime=450}] run particle block yellow_concrete ~ ~1.5 ~ 0.1 0.1 0.1 20 70
execute at @e[type=blaze,scores={LifeTime=450}] run particle block blue_concrete ~ ~1.5 ~ 0.1 0.1 0.1 20 70
execute at @e[type=blaze,scores={LifeTime=450}] run playsound entity.witch.drink master @a ~ ~ ~ 10 2
execute at @e[type=blaze,scores={LifeTime=450}] run effect give @e[type=magma_cube,tag=MegaBoss,distance=..30] absorption 1 5 true
scoreboard players reset @e[type=blaze,scores={LifeTime=500}] LifeTime

#Loot
execute at @e[type=item,scores={InLoot=1},nbt={Item:{tag:{Item:"MagmaArm"}}}] run give @p leather_chestplate{Unbreakable:1,HideFlags:17,Enchantments:[{id:"protection",lvl:999999}],display:{color:11546150,Name:"{\"text\":\"Magma Chestplate\",\"color\":\"light_purple\"}"}}
kill @e[type=item,scores={InLoot=1},nbt={Item:{tag:{Item:"MagmaArm"}}}]
execute at @e[type=item,scores={InLoot=1},nbt={Item:{tag:{Item:"MegaCubeHead"}}}] run give @p player_head{SkullOwner:"MagmaCube",display:{Name:"{\"text\":\"Mega Cube's Head\",\"color\":\"light_purple\"}"}}
kill @e[type=item,scores={InLoot=1},nbt={Item:{tag:{Item:"MagaCubeHead"}}}]

#Kill Mini Cubes
tag @e[type=magma_cube,nbt=!{Size:5}] add MiniCube
execute as @e[tag=MiniCube,nbt={CustomName:"{\"text\":\"   \"}"}] run data merge entity @s {DeathLootTable:"minecraft:entities/vex"}
kill @e[tag=MiniCube,nbt={CustomName:"{\"text\":\"   \"}"}]